﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing.Drawing2D;
using Infragistics.Win.FormattedLinkLabel;

namespace WinGridDottedLine
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.CreationFilter = new MyCrationFilter();
            ultraGrid1.DrawFilter = new MyDrawFilter();
            ultraGrid1.DataSource = GenerateDataSet();
            ultraGrid1.DisplayLayout.Bands[0].Columns[2].EditorComponent = ultraFormattedLinkLabel1;
            ultraFormattedLinkLabel1.LinkAppearance.FontData.Underline = DefaultableBoolean.False;
            ultraFormattedLinkLabel1.VisitedLinkAppearance.FontData.Underline = DefaultableBoolean.False;

        }

        public DataSet GenerateDataSet()
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("ID", typeof(int));
            table0.Columns.Add("Dosage", typeof(int));
            table0.Columns.Add("Drug", typeof(string));
            table0.Columns.Add("Patient", typeof(string));
            table0.Columns.Add("Date", typeof(DateTime));

            table0.Rows.Add(1, 25, "@In&do&cin", "&Da&vi&d", DateTime.Now);
            table0.Rows.Add(2, 50, "Enebrel", "Sam", DateTime.Now);
            table0.Rows.Add(3, 10, "Hydralazine", "Christoff", DateTime.Now);
            table0.Rows.Add(4, 21, "Combivent", "Janet", DateTime.Now);
            table0.Rows.Add(5, 100, "D", "M", DateTime.Now);

            DataTable table1 = new DataTable("Patient Inof");
            table1.Columns.Add("ID", typeof(int));
            table1.Columns.Add("TFID", typeof(int));
            table1.Columns.Add("Name", typeof(string));
            table1.Columns.Add("Inspection", typeof(string));
            table1.Columns.Add("Date", typeof(DateTime));

            table1.Rows.Add(1, 1, "&Da&vi&d", "&Co&nt&ro&l", DateTime.Now);
            table1.Rows.Add(2, 1, "David", "Patient visitation", DateTime.Now);
            table1.Rows.Add(3, 1, "David", "Patient visitation", DateTime.Now);
            table1.Rows.Add(4, 2, "Sam", "Control", DateTime.Now);
            table1.Rows.Add(5, 3, "Christoff", "Control", DateTime.Now);
            table1.Rows.Add(6, 4, "Janet", "Control", DateTime.Now);
            table1.Rows.Add(7, 4, "Janet", "Patient visitation", DateTime.Now);
            table1.Rows.Add(8, 5, "Melanie", "Control", DateTime.Now);
            table1.Rows.Add(9, 5, "M", "Patient visitation", DateTime.Now);


            DataSet RetDataSet = new DataSet();
            RetDataSet.Tables.Add(table0);
            RetDataSet.Tables.Add(table1);
            RetDataSet.Relations.Add(RetDataSet.Tables["Treatment Fluu"].Columns["ID"],
            RetDataSet.Tables["Patient Inof"].Columns["TFID"]);

            return RetDataSet;

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            uiElementViewerDialog1.Show();
        }


        public class MyDrawFilter : IUIElementDrawFilter
        {
            Pen borderPen = new Pen(Brushes.Blue, 1);

            #region Implementation of IUIElementDrawFilter
            public Infragistics.Win.DrawPhase GetPhasesToFilter(ref Infragistics.Win.UIElementDrawParams drawParams)
            {
                //In order to handle the drawing, we need to override the drawing of the 
                //TextUIElement inside the cell. So first, we check to see if the Element
                //is a TextUIElementBase. Second, we check to see if it's context is a cell.
                //If so, we return the BeforeDrawForeGround phase, so we can override it. 
                if ((drawParams.Element is CellUIElement))
                {

                    return DrawPhase.BeforeDrawForeground;
                }
                return new Infragistics.Win.DrawPhase();
            }
            public bool DrawElement(Infragistics.Win.DrawPhase drawPhase, ref Infragistics.Win.UIElementDrawParams drawParams)
            {
                Rectangle elementRect = drawParams.Element.Rect;
                borderPen.DashPattern = new float[] { 10f, 3f, 5f, 3f };
                drawParams.Graphics.DrawLine(this.borderPen, new Point(elementRect.Location.X + 5, elementRect.Bottom - 3),
                                                      new Point(elementRect.Right - 15, elementRect.Bottom - 3));
                
                return true;
            }

            #endregion
        }

        public class MyCrationFilter : IUIElementCreationFilter
        {
            #region IUIElementCreationFilter Members

            public void AfterCreateChildElements(UIElement parent)
            {
                CellUIElement cell = parent as CellUIElement;
                if (cell != null)
                {
                    //FormattedLinkEmbeddableUIElement
                    FormattedLinkEmbeddableUIElement eText = (FormattedLinkEmbeddableUIElement)
                        cell.GetDescendant(typeof(FormattedLinkEmbeddableUIElement));
                    if (eText != null)
                    {
                        eText.Rect = new Rectangle(eText.Rect.Location,
                            new Size(eText.Rect.Width, eText.Rect.Height - 3));
                    }
                }
                //throw new NotImplementedException();
            }

            public bool BeforeCreateChildElements(UIElement parent)
            {
                return false;//throw new NotImplementedException();
            }

            #endregion
        }

    }
}
